<?php
/**
 * Free Wallpaper Script
 *
 * Free Wallpaper Script by Vepa Halliyev is licensed under a Creative Commons Attribution-Share Alike 3.0 License.
 *
 * @package		Free Wallpaper Script
 * @author		Vepa Halliyev
 * @copyright	Copyright (c) 2009, Vepa Halliyev, veppa.com.
 * @license		http://www.veppa.com/free-wallpaper-script/
 * @link		http://www.veppa.com/free-wallpaper-script/
 * @since		Version 1.0
 * @filesource
 */
/**
 * class Comment
 *
 * @author Vepa Halliyev <veppa.com>
 * @since  0.1
 */

class Comment extends Record
{
	const TABLE_NAME = 'comment';
	
	private static $cols = array(
		'cm_id'	=>	1,         
		'cm_wid'	=>	1,         
		'cm_name'	=>	1,         
		'cm_website'	=>	1,         
		'cm_body'	=>	1,         
		'cm_active'	=>	1,
		'cm_ip'	=>	1,         
		'cm_added_at'	=>	1,         
		'cm_added_by'	=>	1 
	);

	public function __construct($data = false, $locale_db = false)
	{
		$this->setColumns(self::$cols);
		parent::__construct($data,$locale_db);
	}
	
	function beforeInsert()
	{
		$this->cm_ip = Controller::input()->ip_address();
		$this->cm_added_at = REQUEST_TIME;
		$this->cm_added_by = AuthUser::$user->id;
		return true;
	}
	
	function afterInsert()
	{
		Wallpaper::updateNumComments($this->cm_wid);
		return true;
	}
	
	function afterDelete()
	{
		Wallpaper::updateNumComments($this->cm_wid);
		return true;
	}
	
} // end User class
