<?php
/**
 * Free Wallpaper Script
 *
 * Free Wallpaper Script by Vepa Halliyev is licensed under a Creative Commons Attribution-Share Alike 3.0 License.
 *
 * @package		Free Wallpaper Script
 * @author		Vepa Halliyev
 * @copyright	Copyright (c) 2009, Vepa Halliyev, veppa.com.
 * @license		http://www.veppa.com/free-wallpaper-script/
 * @link		http://www.veppa.com/free-wallpaper-script/
 * @since		Version 1.0
 * @filesource
 */
/**
 * class Config
 *
 * @author Vepa Halliyev <veppa.com>
 * @since  0.1
 */

class Config extends Record
{
	const TABLE_NAME = 'config';
	
	static $conf = false;
	private static $loaded = false;
	
	
	private static $cols = array(
		'name'	=>	1,                         
		'val'	=>	1,         
		'is_editable'	=>	1
	);
	

	public function __construct($data = false, $locale_db = false)
	{
		$this->setColumns(self::$cols);
		parent::__construct($data,$locale_db);
	}

	
	public function option($name)
	{
		self::load();
		return self::$conf->{$name};
	}
	
	public function optionSet($name,$value)
	{
		// read from db 
		$opt = self::findOneFrom('Config','name=?',array($name));
		//print_r($opt);
		
		if($opt)
		{
			// update record
			$opt->val = $value;
			$opt->save('name');
		}
		else
		{
			// save as new record
			$opt = new Config();
			$opt->val = $value;
			$opt->name = $name;
			$opt->save('no_id');
		}
		
		
		self::$conf->{$name} = $value;
	}
	
	public function load()
	{
		if(!self::$loaded)
		{
			$c = self::findAllFrom('Config');
			self::$conf = new stdClass();
			foreach($c as $c_)
			{
				self::$conf->{$c_->name} = $c_->val;
			}
			self::$loaded = true;
		}
		
		return self::$conf;
	}
	
	static function urlAssets()
	{
		// check if template set then load template location 
		return self::urlTemplate().'public/';
	}
	
	static function urlTemplate()
	{
		$template = self::option('template');
		return BASE_URL.'user-content/templates/'.$template.'/';
	}
	
} // end User class
