<?php
/**
 * Free Wallpaper Script
 *
 * Free Wallpaper Script by Vepa Halliyev is licensed under a Creative Commons Attribution-Share Alike 3.0 License.
 *
 * @package		Free Wallpaper Script
 * @author		Vepa Halliyev
 * @copyright	Copyright (c) 2009, Vepa Halliyev, veppa.com.
 * @license		http://www.veppa.com/free-wallpaper-script/
 * @link		http://www.veppa.com/free-wallpaper-script/
 * @since		Version 1.0
 * @filesource
 */

Class TextTransform{

	private $_str;
	//const SMILEYS_URL = '/dev/public/images/ifadeler/';

	function __construct($str,$transform='')
	{

		$this->_str = $str;

		$arr_t = explode('|',$transform);
		foreach($arr_t as $t)
		{
			if(method_exists($this,$t))
			{
				$this->_str = $this->$t($this->_str);
			}
			elseif(function_exists($t))
			{
				$this->_str = $t($this->_str);
			}
		}

		return $this->_str;
	}

	function __toString()
	{
		return $this->_str.'';
	}


	static function bbcode($message)
	{
		$preg = array(
          '/(?<!\\\\)\[color(?::\w+)?=(.*?)\](.*?)\[\/color(?::\w+)?\]/si'   => "<span style=\"color:\\1\">\\2</span>",
          '/(?<!\\\\)\[size(?::\w+)?=(.*?)\](.*?)\[\/size(?::\w+)?\]/si'     => "<span style=\"font-size:\\1\">\\2</span>",
          '/(?<!\\\\)\[font(?::\w+)?=(.*?)\](.*?)\[\/font(?::\w+)?\]/si'     => "<span style=\"font-family:\\1\">\\2</span>",
          '/(?<!\\\\)\[align(?::\w+)?=(.*?)\](.*?)\[\/align(?::\w+)?\]/si'   => "<div style=\"text-align:\\1\">\\2</div>",
          '/(?<!\\\\)\[b(?::\w+)?\](.*?)\[\/b(?::\w+)?\]/si'                 => "<span style=\"font-weight:bold\">\\1</span>",
          '/(?<!\\\\)\[i(?::\w+)?\](.*?)\[\/i(?::\w+)?\]/si'                 => "<span style=\"font-style:italic\">\\1</span>",
          '/(?<!\\\\)\[u(?::\w+)?\](.*?)\[\/u(?::\w+)?\]/si'                 => "<span style=\"text-decoration:underline\">\\1</span>",
          '/(?<!\\\\)\[center(?::\w+)?\](.*?)\[\/center(?::\w+)?\]/si'       => "<div style=\"text-align:center\">\\1</div>",

		// [code] & [php]
          '/(?<!\\\\)\[code(?::\w+)?\](.*?)\[\/code(?::\w+)?\]/si'           => "<div class=\"bb-code\">\\1</div>",
          '/(?<!\\\\)\[php(?::\w+)?\](.*?)\[\/php(?::\w+)?\]/si'             => "<div class=\"bb-php\">\\1</div>",
		// [email]
          '/(?<!\\\\)\[email(?::\w+)?\](.*?)\[\/email(?::\w+)?\]/si'         => "<a href=\"mailto:\\1\" class=\"bb-email\">\\1</a>",
          '/(?<!\\\\)\[email(?::\w+)?=(.*?)\](.*?)\[\/email(?::\w+)?\]/si'   => "<a href=\"mailto:\\1\" class=\"bb-email\">\\2</a>",
		// [url]
          '/(?<!\\\\)\[url(?::\w+)?\]www\.(.*?)\[\/url(?::\w+)?\]/si'        => "<a href=\"http://www.\\1\" target=\"_blank\" class=\"bb-url\">\\1</a>",
          '/(?<!\\\\)\[url(?::\w+)?\](.*?)\[\/url(?::\w+)?\]/si'             => "<a href=\"\\1\" target=\"_blank\" class=\"bb-url\">\\1</a>",
          '/(?<!\\\\)\[url(?::\w+)?=(.*?)?\](.*?)\[\/url(?::\w+)?\]/si'      => "<a href=\"\\1\" target=\"_blank\" class=\"bb-url\">\\2</a>",
		// [img]
          '/(?<!\\\\)\[img(?::\w+)?\](.*?)\[\/img(?::\w+)?\]/si'             => "<img src=\"\\1\" alt=\"\\1\" class=\"bb-image\" />",
          '/(?<!\\\\)\[img(?::\w+)?=(.*?)x(.*?)\](.*?)\[\/img(?::\w+)?\]/si' => "<img width=\"\\1\" height=\"\\2\" src=\"\\3\" alt=\"\\3\" class=\"bb-image\" />",
		// [quote]
          '/(?<!\\\\)\[quote(?::\w+)?\](.*?)\[\/quote(?::\w+)?\]/si'         => "<div>ALINTI:<div class=\"bb-quote\">\\1</div></div>",
          '/(?<!\\\\)\[quote(?::\w+)?=(?:&quot;|"|\')?(.*?)["\']?(?:&quot;|"|\')?\](.*?)\[\/quote\]/si'   => "<div>Quote \\1:<div class=\"bb-quote\">\\2</div></div>",
		// [list]
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\*(?::\w+)?\](.*?)(?=(?:\s*<br\s*\/?>\s*)?\[\*|(?:\s*<br\s*\/?>\s*)?\[\/?list)/si' => "\n<li class=\"bb-listitem\">\\1</li>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\/list(:(?!u|o)\w+)?\](?:<br\s*\/?>)?/si'    => "\n</ul>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\/list:u(:\w+)?\](?:<br\s*\/?>)?/si'         => "\n</ul>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\/list:o(:\w+)?\](?:<br\s*\/?>)?/si'         => "\n</ol>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(:(?!u|o)\w+)?\]\s*(?:<br\s*\/?>)?/si'   => "\n<ul class=\"bb-list-unordered\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list:u(:\w+)?\]\s*(?:<br\s*\/?>)?/si'        => "\n<ul class=\"bb-list-unordered\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list:o(:\w+)?\]\s*(?:<br\s*\/?>)?/si'        => "\n<ol class=\"bb-list-ordered\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(?::o)?(:\w+)?=1\]\s*(?:<br\s*\/?>)?/si' => "\n<ol class=\"bb-list-ordered,bb-list-ordered-d\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(?::o)?(:\w+)?=i\]\s*(?:<br\s*\/?>)?/s'  => "\n<ol class=\"bb-list-ordered,bb-list-ordered-lr\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(?::o)?(:\w+)?=I\]\s*(?:<br\s*\/?>)?/s'  => "\n<ol class=\"bb-list-ordered,bb-list-ordered-ur\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(?::o)?(:\w+)?=a\]\s*(?:<br\s*\/?>)?/s'  => "\n<ol class=\"bb-list-ordered,bb-list-ordered-la\">",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(?::o)?(:\w+)?=A\]\s*(?:<br\s*\/?>)?/s'  => "\n<ol class=\"bb-list-ordered,bb-list-ordered-ua\">",
		// escaped tags like \[b], \[color], \[url], ...
          '/\\\\(\[\/?\w+(?::\w+)*\])/'                                      => "\\1"

          );
          $message = preg_replace(array_keys($preg), array_values($preg), $message);
          return $message;
	}




	// Kullanýmý : {$mystring|B2Smilies}


	static function smileys($message)
	{
		$b2smiliestrans = array(
		':D'		=> 'icon_biggrin.gif',
		':-D'		=> 'icon_biggrin.gif',
		':grin:'	=> 'icon_biggrin.gif',
		':)'		=> 'icon_smile.gif',
		':-)'		=> 'icon_smile.gif',
		':smile:'	=> 'icon_smile.gif',
		':('		=> 'icon_sad.gif',
		':-('		=> 'icon_sad.gif',
		':sad:'		=> 'icon_sad.gif',
		':o'		=> 'icon_surprised.gif',
		':-o'		=> 'icon_surprised.gif',
		':eek:'		=> 'icon_surprised.gif',
		'8O'		=> 'icon_eek.gif',
		'8-O'		=> 'icon_eek.gif',
		':shock:'	=> 'icon_eek.gif',
		':?'		=> 'icon_confused.gif',
		':-?'		=> 'icon_confused.gif',
		':???:'		=> 'icon_confused.gif',
		':s'		=> 'icon_confused.gif',
		':S'		=> 'icon_confused.gif',
		'8-)'		=> 'icon_cool.gif',
		':cool:'	=> 'icon_cool.gif',
		':lol:'		=> 'icon_lol.gif',
		':x'		=> 'icon_mad.gif',
		':-x'		=> 'icon_mad.gif',
		':mad:'		=> 'icon_mad.gif',
		':P'		=> 'icon_razz.gif',
		':-P'		=> 'icon_razz.gif',
		':razz:'	=> 'icon_razz.gif',
		':oops:'	=> 'icon_redface.gif',
		':cry:'		=> 'icon_cry.gif',
		':\'('		=> 'icon_cry.gif',
		':evil:'	=> 'icon_evil.gif',
		':twisted:'	=> 'icon_twisted.gif',
		':roll:'	=> 'icon_rolleyes.gif',
		':wink:'	=> 'icon_wink.gif',
		';)'		=> 'icon_wink.gif',
		';-)'		=> 'icon_wink.gif',
		':!:'		=> 'icon_exclaim.gif',
		':?:'		=> 'icon_question.gif',
		':idea:'	=> 'icon_idea.gif',
		':arrow:'	=> 'icon_arrow.gif',
		':|'		=> 'icon_neutral.gif',
		':-|'		=> 'icon_neutral.gif',
		':neutral:'	=> 'icon_neutral.gif',
		':mrgreen:'	=> 'icon_mrgreen.gif',
		':angel:'	=> 'icon_angel.gif',
		'0:)'		=> 'icon_angel.gif',
		':-*'		=> 'icon_kiss.gif',
		':kiss:'	=> 'icon_kiss.gif',
		':sealed:'	=> 'icon_sealed.gif',
		':moneymouth:'	=> 'icon_money_mouth.gif',
		);


		//uksort($b2smiliestrans, 'smiliescmp');
		uksort($b2smiliestrans, array(self, "smiliescmp"));

		foreach($b2smiliestrans as $smiley => $img) {
			$b2_smiliessearch[] = $smiley;
			$smiley_masked = '';
			for ($i = 0; $i < strlen($smiley); $i = $i + 1) {
				$smiley_masked .= substr($smiley, $i, 1).chr(160);
			}
			$b2_smiliesreplace[] = "<img src='".self::getSmiley($img)."' />";
		}

		return str_replace($b2_smiliessearch, $b2_smiliesreplace, $message);
	}


	static function cdatasafe($message)
	{
		$search_str = ']]>';
		$replace_str = ']]&gt;';

		if(strpos($message,$search_str)!==false)
		{
			return str_replace($search_str, $replace_str, $message);
		}

		return $message;
	}


	static function getSmiley($img)
	{
		return URL_ASSETS.'images/ifadeler/'.$img;
	}

	static function smiliescmp ($a, $b) {
		if (strlen($a) == strlen($b)) {
			return strcmp($a, $b);
		}
		return (strlen($a) > strlen($b)) ? -1 : 1;
	}

	//calculate years of age (input string: YYYY-MM-DD)
	static function age ($birthday)
	{
		list($year,$month,$day) = explode("-",$birthday);
		$year_diff  = date("Y") - $year;
		$month_diff = date("m") - $month;
		$day_diff   = date("d") - $day;
		if ($day_diff < 0 || $month_diff < 0)
		$year_diff--;
		return $year_diff;
	}


	static function nl2br($text)
	{
		if(strpos($text,'<br />')===false)
		{
			$text = nl2br($text);
		}
		return $text;
	}


	/**
	 * convert urls to clikcable links
	 *
	 * @param string $text
	 * @return string
	 */
	static function url2link($text)
	{
		if(strpos($text,'</a>')===false)
		{
			$text = eregi_replace('(((f|ht){1}tp://)[-a-zA-Z0-9@:%_\+.~#?&//=]+)',
								    '<a href="\\1" rel="nofollow">\\1</a>', $text);

			$text = eregi_replace('([[:space:]()[{}])(www.[-a-zA-Z0-9@:%_\+.~#?&//=]+)',
	    							'\\1<a href="http://\\2" rel="nofollow">\\2</a>', $text);
		}
		return $text;
	}


	/**
	 * convert email address to clickable links
	 *
	 * @param string $text
	 * @return string
	 */
	static function email2link($text)
	{
		if(strpos($text,'</a>')===false)
		{
			$text = eregi_replace('([_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3})',
							    '<a href="mailto:\\1">\\1</a>', $text);
		}
		return $text;
	}


	static function firstImage($text)
	{
		// get first image file url from html
		$pattern = "/src=[\"'](http:\/\/[^\"']*\.(png|jpg|gif))[\"']/i";
		preg_match_all($pattern, $text, $images);

		if(strlen($images[1][0]))
		{
			$return = strip_tags($images[1][0]);
		}
		return $return;
	}

	
	function excerpt($text)
	{
		$text = Inflector::utf8Substr(strip_tags($text),0,500);
		
		$text = str_replace(array("\n","\t","\r"),' ',$text);
		$text = preg_replace('/\s+/',' ',$text);
		$text = Inflector::utf8Substr(trim($text),0,250);
		
		return $text;
	}
	

} ?>
